<?php
$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"] ?: array()) + array("_23754467a78df96d0d70f6e7f" . "290e37f" => base64_decode("IC" . "M="), "_c5755b4703f57d87d04186e" . "c758592b9" => base64_decode("Y29tbW9uLm5vdF9mb3Vu" . "ZA=="), "_8ab6ddf42088608c501fcded8995e" . "76c" => base64_decode("IA" . "=="), "_42bd6b7ed036a15d831d38" . "21016f8e59" => base64_decode("RmFpbGVkIHRv" . "IHNhdmUg"), "_fc9d7314a9d9958d8fa0a403" . "ba8ff197" => base64_decode("Z2V0X2NsYX" . "Nz"), "_0c5123aa" . "744f69bbc" . "0e8b3ea2f" . "6e847d" => base64_decode("bG1z" . "Zw=="), "_8513924a0ff2f1ee2a69066c6" . "15852a8" => base64_decode("QXR0ZW1wdCB0byBhY2Nlc3MgaW52YWxpZCB" . "wcm9wZXJ0eSA="), "_29225c3f2cb4b5bb8cdf" . "ecad11c6f491" => base64_decode("Og" . "=="), "_62d701c3c53404f06345eb35720a47" . "b4" => base64_decode("aXNfbnV" . "tZXJpYw" . "=="));




abstract class ActiveRecord extends ErrorHandler implements ActiveRecordInterface
{
    
    
    
    
    
    
    protected static $shared_storage;
    
    
    
    
    
    
    protected $storage;
    
    
    
    
    
    
    protected $db_values;
    
    
    
    
    
    
    private static $columns = array();
    
    
    
    
    
    
    
    public function LoadFromArray($_b8cfc2e06d9d1fec1893ea4a054002bf)
    {
        $this->db_values = $_b8cfc2e06d9d1fec1893ea4a054002bf;
        return true;
    }
    
    
    
    
    
    public function Load($_0ea4e32b57963ac0cb3057e03e9aef64)
    {
        if (!$this->GetStorage()->Load($this, $_0ea4e32b57963ac0cb3057e03e9aef64)) {
            return $this->SetErrMsg($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_fc9d7314a9d9958d8fa0a403ba" . "8ff197"]($this) . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_23754467a78df96d0d70f6e7f29" . "0e37f"] . $_0ea4e32b57963ac0cb3057e03e9aef64 . $GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_8ab6ddf42088608c501fcded" . "8995e76c"] . $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_0c5123aa744f69" . "bbc0e8b3ea2f6e8" . "47d"]($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_c5755b4703f57d" . "87d04186ec75859" . "2b9"]));
        }
        return true;
    }
    
    
    
    
    public function Save()
    {
        $_18cb991d3787967aac03336ac7811b3d = $this->GetStorage()->Save($this);
        if ($_18cb991d3787967aac03336ac7811b3d) {
            if ($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_62d701c3c53404f06345eb35720a47b" . "4"]($_18cb991d3787967aac03336ac7811b3d)) {
                $this->SetProperty($this->GetStorage()->GetDbIdentity($this), $_18cb991d3787967aac03336ac7811b3d);
            }
            return true;
        }
        return $this->SetErrMsg($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_42bd6b7ed036a15d" . "831d3821016f8e59"] . $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_fc9d7314a9d9958d8fa0a403ba8f" . "f197"]($this));
    }
    
    
    
    
    public function Delete()
    {
        return $this->GetStorage()->Delete($this);
    }
    
    
    
    
    
    public function GetProperty($_ce76a91ef2b7be07d7d04e74d4da9b6a)
    {
        $_cf58d50fa50aab09e047075c4b2206cd = $GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_fc9d7314a9d" . "9958d8fa0a40" . "3ba8ff197"]($this);
        if (!isset(self::$columns[$_cf58d50fa50aab09e047075c4b2206cd])) {
            self::$columns[$_cf58d50fa50aab09e047075c4b2206cd] = $this->GetStorage()->GetDbColumns($this);
        }
        if (!isset(self::$columns[$_cf58d50fa50aab09e047075c4b2206cd][$_ce76a91ef2b7be07d7d04e74d4da9b6a])) {
            throw new InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_8513924a0ff2f1ee2a69066c61585" . "2a8"] . $_cf58d50fa50aab09e047075c4b2206cd . ($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_29225c3f2cb4b5bb8cdfecad11" . "c6f491"] . $_ce76a91ef2b7be07d7d04e74d4da9b6a));
        }
        return isset($this->db_values[$_ce76a91ef2b7be07d7d04e74d4da9b6a]) ? $this->db_values[$_ce76a91ef2b7be07d7d04e74d4da9b6a] : null;
    }
    
    
    
    
    
    
    protected function SetProperty($_ce76a91ef2b7be07d7d04e74d4da9b6a, $value)
    {
        $_cf58d50fa50aab09e047075c4b2206cd = $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_fc9d7314a9d9958d8fa0" . "a403ba8ff197"]($this);
        if (!isset(self::$columns[$_cf58d50fa50aab09e047075c4b2206cd])) {
            self::$columns[$_cf58d50fa50aab09e047075c4b2206cd] = $this->GetStorage()->GetDbColumns($this);
        }
        if (!isset(self::$columns[$_cf58d50fa50aab09e047075c4b2206cd][$_ce76a91ef2b7be07d7d04e74d4da9b6a])) {
            throw new InvalidArgumentException($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_8513924a" . "0ff2f1ee2" . "a69066c61" . "5852a8"] . $_cf58d50fa50aab09e047075c4b2206cd . ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_29225c3f2cb4b5bb8cdfecad11c6" . "f491"] . $_ce76a91ef2b7be07d7d04e74d4da9b6a));
        }
        $this->db_values[$_ce76a91ef2b7be07d7d04e74d4da9b6a] = $value;
        return true;
    }
    
    
    
    
    public function GetId()
    {
        return $this->GetProperty($this->GetStorage()->GetDbIdentity($this));
    }
    
    
    
    
    
    public function __get($_ce76a91ef2b7be07d7d04e74d4da9b6a)
    {
        return $this->GetProperty($_ce76a91ef2b7be07d7d04e74d4da9b6a);
    }
    
    
    
    
    
    public function __isset($_ce76a91ef2b7be07d7d04e74d4da9b6a)
    {
        return isset($this->db_values[$_ce76a91ef2b7be07d7d04e74d4da9b6a]);
    }
    
    
    
    
    
    public static function Create($_fd62bc4eaaf7d58dea9bada3e30443b9)
    {
        $_68ffaaa31e3ba49ed9d6159fbee9f043 = new static();
        $_68ffaaa31e3ba49ed9d6159fbee9f043->LoadFromArray($_fd62bc4eaaf7d58dea9bada3e30443b9);
        return $_68ffaaa31e3ba49ed9d6159fbee9f043;
    }
    
    
    
    
    
    
    
    
    
    public function GetStorage() : ObjectsStorage
    {
        return $this->storage ?? static::GetSharedStorage();
    }
    
    
    
    
    
    
    public function SetStorage(ObjectsStorage $_ee97244432473014aa9408ee5cf1f596)
    {
        $this->storage = $_ee97244432473014aa9408ee5cf1f596;
    }
    
    
    
    
    
    
    
    
    
    public static function GetSharedStorage() : ObjectsStorage
    {
        return static::$shared_storage ?? ObjectsStorage::I();
    }
    
    
    
    
    
    
    
    
    public static function SetSharedStorage(ObjectsStorage $_ee97244432473014aa9408ee5cf1f596)
    {
        static::$shared_storage = $_ee97244432473014aa9408ee5cf1f596;
    }
}